data NEW1;
   dcl double TOTAL;
   vararray double CONTRIB[*] QTR1-QTR4;
   method run();
      dcl integer q; 
      set {select EMPLOYEE_ID,QTR1,QTR2,QTR3, QTR4 
              from ORION.EMPLOYEE_DONATIONS
              WHERE FIND (RECIPIENTS,'%’)};
      TOTAL = 0.0;
      do Q = 1.0 to DIM(CONTRIB);
         TOTAL + CONTRIB[Q] * 1.25;
      end;
   end;
enddata;
run;
proc ds2;
thread work.th_Donation/overwrite=yes;
   vararray double contrib[*] qtr:;
   dcl double Total;
   method run();
      dcl int q;
      set {select Employee_ID, qtr1
                , qtr2, qtr3, qtr4 
      from orion.employee_donations
      where find(recipients,'%')>0};
      Total=0;
      do q=1 to dim(contrib);
         Total+contrib[q]*1.25;
      end;
   end;
endthread;
run;
quit;

proc ds2;
data new /overwrite=yes ;
   dcl thread work.th_Donation th;
   method run();
      set from th threads=4;
   end;
enddata;
run;
quit;
